From f3a9afae5015971cc8b3e857c6dadbb9142bd3f8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 09 2020 06:22:15 +0000
Subject: [PATCH 1014/2232] Omit empty derive attribute


Previously an empty #[derive()] would appear distractingly in
macro-expanded code.

---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
new file mode 100644
index 0000000..1abc5da
--- /dev/null
+++ b/macro/src/derive.rs
@@ -0,0 +1,14 @@
+use crate::syntax::Derive;
+use proc_macro2::TokenStream;
+use quote::{quote, ToTokens};
+
+pub struct DeriveAttribute<'a>(pub &'a [Derive]);
+
+impl<'a> ToTokens for DeriveAttribute<'a> {
+    fn to_tokens(&self, tokens: &mut TokenStream) {
+        if !self.0.is_empty() {
+            let derives = self.0;
+            tokens.extend(quote!(#[derive(#(#derives),*)]));
+        }
+    }
+}
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 20f166f..cb3babd 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,3 +1,4 @@
+use crate::derive::DeriveAttribute;
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::file::Module;
 use crate::syntax::namespace::Namespace;
@@ -128,7 +129,7 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
 fn expand_struct(namespace: &Namespace, strct: &Struct) -> TokenStream {
     let ident = &strct.ident;
     let doc = &strct.doc;
-    let derives = &strct.derives;
+    let derives = DeriveAttribute(&strct.derives);
     let type_id = type_id(namespace, ident);
     let fields = strct.fields.iter().map(|field| {
         // This span on the pub makes "private type in public interface" errors
@@ -139,7 +140,7 @@ fn expand_struct(namespace: &Namespace, strct: &Struct) -> TokenStream {
 
     quote! {
         #doc
-        #[derive(#(#derives),*)]
+        #derives
         #[repr(C)]
         pub struct #ident {
             #(#fields,)*
diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index fae874a..291b03c 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -9,6 +9,7 @@
 
 extern crate proc_macro;
 
+mod derive;
 mod expand;
 mod syntax;
 mod type_id;

